;***************************************************************
;****** Does mem copies with 32 bit offsets
;***************************************************************
                ideal
                %crefref
                %noincl
                %nomacs
                p386

;		model	large
;               include "help.asi"
;               include "386.asi"
;               include "seg0.asi"
;               include "system.asi"



;###### CODE ###################################################
;               codeseg
        segment ASM_TEXT word public 'CODE'
                assume  cs:ASM_TEXT


;***************************************************************
;void memcpy32(u32 addr, const void* buf, size_t size);
;****** Uses:   Flags
;***************************************************************
        global  _memcpy32:far
        proc    _memcpy32 far

;***************************************************************
                arg     dstseg  :word,  \
                        dstofs  :dword, \
                        srcseg  :word,  \
                        srcofs  :dword, \
                        size    :dword  = PARAM_SIZE

;***************************************************************
                push    bp
                mov     bp,sp

                push    ds es ecx esi edi
                mov     ds,[srcseg]
                mov     esi,[srcofs]
                mov     es,[dstseg]
                mov     edi,[dstofs]
                mov     ecx,[size]
                cld
                db      67h     ;Address width override for esi/edi
                db      66h     ;Operand width override for ecx
            rep movsb
                pop     edi esi ecx es ds

;****** Return *************************************************
                pop     bp
                retf
        endp    _memcpy32

        ends    ASM_TEXT

        end

;###### END OF FILE ############################################
