;***************************************************************
;******
;***************************************************************
                ideal
                %crefref
                %noincl
                %nomacs
                p386

;		model	large
;               include "help.asi"
;               include "386.asi"
;               include "seg0.asi"
;               include "system.asi"



;###### CODE ###################################################
;               codeseg
        segment ASM_TEXT word public 'CODE'
                assume  cs:ASM_TEXT


;***************************************************************
;Get xmm driver addr or 0 if no xmm
;void* xmm_driver()
;***************************************************************
        global  _xmm_driver:far
        proc    _xmm_driver far

;***************************************************************
                push    es bx

                mov     ax,4300h
                int     2fh
                cmp     al,80h
                jne     @@err
                mov     ax,4310h
                int     2fh
                mov     dx,es
                mov     ax,bx
                jmp     @@ret
@@err:
                xor     dx,dx
                xor     ax,ax
;***************************************************************
@@ret:
                pop     bx es
                retf
        endp    _xmm_driver


;***************************************************************
;u32 xmm_alloc(void* drv, u32 size)
;***************************************************************
        global  _xmm_alloc:far
        proc    _xmm_alloc far
                arg     drv     :dword, \
                        size    :dword  = PARAM_SIZE

;***************************************************************
                push    bp
                mov     bp,sp

                push    ebx

                mov     ebx,[size]      ;round up and convert to kb
                add     ebx,3ffh        ;
                shr     ebx,10          ;
                mov     dx,bx
                mov     ah,09h          ;allocate blk
                call    [drv]           ;
                test    ax,ax
                jz      @@err
                                        ;now: dx=handle of the blk
                mov     ah,0Ch          ;lock blk
                call    [drv]           ;
                test    ax,ax
                jz      @@err
                                        ;now: dx:bx=addr of blk
                mov     ax,bx
                jmp     @@ret
@@err:
                xor     dx,dx
                xor     ax,ax
;***************************************************************
@@ret:
                pop     ebx
                pop     bp
                retf
        endp    _xmm_alloc


        ends    ASM_TEXT

        end

;###### END OF FILE ############################################
